/**********************************************************
PicView for E2 
Written  by Strelok Vlad Kolerts
10/02/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#define QT_NO_DRAGANDDROP
#define QT_NO_PROPERTIES
#include <ZApplication.h>
#include <ZKbMainWidget.h>

#include <qfontmanager_qws.h>
#include <qfontdatabase.h>
#include <qtextstream.h>
#include <qtextcodec.h>
#include <qpixmapcache.h>
#include <qtimer.h>
#include <qmovie.h>

#include <stdlib.h>
#include <stdio.h>
#include <qdir.h>

//#include <qwallpaper.h>
#include <SETUP_API.h>
#include <UTIL_Graph.h>
#include "tools/TextView.h"


QTextCodec* gbk_codec = QTextCodec::codecForName("UTF-8");
QString Rus(const char*ChineseString)
{
	return gbk_codec->toUnicode(ChineseString);
}

class mainWidget : public ZKbMainWidget
{
	Q_OBJECT
	QString 	ProgDir;
	QString 	path;
	QString		mime_filter;
	
	TextView*	textView;
	QMovie*		gif;

	QPainter	p;
	QPixmap		pm;
	///QPixmap		pm_temp;
	QPixmap		titl;
		int		tit_c;
	QPixmap* 	bg_buf;
	QPixmap		about_icon;
	QString		image_way;
	QStringList images;
	
	QTimer		*slide_timer;

	QString		text, resol, size;
	
	QString		title, text1, text2, text3, text4, text5;

	int x, y, x_end, y_end;
	int zoom_x, zoom_y, pm_h, pm_w, zoom_c;
	int move_step;

	int angle;
	
	bool DrawInfo, RedRect;
	bool PrewNextImg;

	bool left, right, up, down;
	bool zoom_p, zoom_m;
	int zoom_procent;
	bool prewImg, nextImg;
	bool push_green;
	bool animated, gifPause;
	
	bool SlideShow, smoothZoom, recount;

	int exit_count;
	bool repaint, exit;
	
public:
mainWidget(QString way_image):ZKbMainWidget((ZHeader::HEADER_TYPE)3,NULL , "ZMainWidget" , 0)
	{
		ProgDir=getPath(QString ( qApp->argv() [0] ));
		
		path=getPath(way_image);
		QString work_dir=getWorkDir(ProgDir);
		
		textView = new TextView();
		//gif = new QMovie(way_image);
		//gif->connectUpdate(this, SLOT(gifUpdated()));
		
		/*QFile file(work_dir+"mime_types.cfg");
		if( file.open(IO_ReadOnly) )		
		{
			//int i=0;
			QTextStream	stream( &file );
			QString		temp_line;
			while(temp_line=stream.readLine())
			{
				if(atoi(temp_line.mid(0,3))==2)	mime_filter+="*."+temp_line.mid(7,10)+" ";
				//i++;
			}
			file.close();	
		}*/
		mime_filter="*."+QString(QImage::inputFormatList().join(" *.")).upper();
		
		QDir dir( path, mime_filter);
		dir.setMatchAllDirs ( false );
		if ( !dir.isReadable() )
		return;
		images = dir.entryList();
		images.sort();
		
		QFontFactory *factory = qt_fontmanager->factories.at(0);
		QDiskFont *qdf = new QDiskFont(factory, "KolertsFont", false, 25, 0, "s",work_dir+"res/font.ttf");
		qt_fontmanager->diskfonts.append(qdf);
		QFontDatabase::qwsAddDiskFont(qdf);
		
		QFont font("KolertsFont",15,10,false);
		setFont(font);
		textView->setFont(font);
		
		exit_count=30;
		image_way=way_image;
		
		about_icon=QPixmap(ProgDir+"PicView.png");
		
		QImage 	img(ProgDir+"px.png");
		img=img.smoothScale( 240, 20 );
		titl.convertFromImage(img);
		tit_c=-1;
		
		bg_buf = new QPixmap(240,320);
		setFullScreenMode(true, true);		
		setBackgroundColor( Qt::black );	
		resize( 240, 320 );
		QPixmapCache::setCacheLimit(1024*30);

		exit=false;
		repaint=false;
		left=false;
		right=false;
		up=false;
		down=false;
		zoom_p=false;
		zoom_m=false;
		prewImg=false;
		nextImg=false;
		push_green=false;
		DrawInfo=false;
		RedRect=false;
		SlideShow=false;
		smoothZoom=false;
		animated=false;
		recount=false;
		PrewNextImg=true;
		
		QTimer *timer = new QTimer(this);
		connect( timer, SIGNAL(timeout()), SLOT(animate()) );
		timer->start( 60 );
		
		slide_timer = new QTimer(this);
		connect( slide_timer, SIGNAL(timeout()), SLOT(slideShow()) );
		
		//gif->connectResize(this, SLOT(movieResized(const QSize&)));
		//gif->connectStatus(this, SLOT(movieStatus(int)));
		
		///	Check copyrites
		if (!ypoCkhc())
		{
			exit=true;
			exit_count=1;
		}
	}	

~mainWidget()
	{			
	}
	
void loadFile(QString file, bool upd)
	{
		///pm_temp=QPixmap(file);
		///pm=pm_temp;
		////pm=QPixmap(file);
		
		if(!QPixmapCache::find(file, pm))
		{
			if(upd)
				paintProc("Loading image...", true);
			pm.load(file);
			QPixmapCache::insert(file, pm);
		}
		else
			if(upd)
				paintProc("Loading cached image...", true);
		if(upd)
		{
			setImgChar();
			repaint=true;
		}
		
		//QString mime=getMime(file);
		//if(mime=="gif" || mime=="GIF")
		//{
			//gif->pause();
			if(gif)
			{
				gif->disconnectUpdate(this, SLOT(gifUpdated()));
				delete gif;
				gif=NULL;
			}
			
			gif = new QMovie(file);
			gif->connectUpdate(this, SLOT(gifUpdated()));
			//gif->unpause();
		//}
		animated=false;
		gifPause=false;
	}
	
void paint()
	{
		ChkPos();
		p.begin( bg_buf ,this);
		p.setPen(Qt::black);
		p.setBrush(Qt::black);
		p.drawRect( 0, 0, 240, 320 );
		
		if(RedRect)
		{
			p.setPen(Qt::red);
			p.drawRect( x-1, y-1, zoom_x+2, zoom_y+2 );
			p.setPen(Qt::black);
		}
		
		p.drawPixmap(x, y, pm);
		
		if(tit_c>0 or DrawInfo)
		{
			p.drawPixmap(0, 0, titl);
			p.drawText(10, 15, text, -1, QPainter::RTL);
			if(DrawInfo)
			{
				p.drawPixmap(0, 20, titl);
				p.drawText(10, 35, resol+QString(" %1 %").arg(zoom_procent), -1, QPainter::RTL);
				p.drawPixmap(0, 40, titl);
				p.drawText(10, 55, size, -1, QPainter::RTL);
				/*QString mime="Format: "+getMime(image_way);
				if(animated)
					mime+="(animated)";
				p.drawPixmap(0, 60, titl);
				p.drawText(10, 75, mime, -1, QPainter::RTL);*/
			}
		}
		p.end();		
		
		bitBlt( this,0, 0, bg_buf );
		
		repaint=false;
	}

void paintProc(QString process_text, bool rep)
	{
		p.begin( bg_buf ,this);
		if(rep) 
		{
			p.drawPixmap(x, y, pm);
			if(DrawInfo)
			{
				p.drawPixmap(0, 0, titl);
				p.drawPixmap(0, 20, titl);
				p.drawPixmap(0, 40, titl);
				
				p.drawText(10, 15, text, -1, QPainter::RTL);
				p.drawText(10, 35, resol+QString(" %1 %").arg(zoom_procent), -1, QPainter::RTL);
				p.drawText(10, 55, size, -1, QPainter::RTL);
			}
		}
		p.drawPixmap(0, 300, titl);
		p.drawText(0, 300, 240, 20, Qt::AlignCenter, process_text, -1, 0);
		p.end();
		bitBlt( this,0, 0, bg_buf );
	}

void paintAbout()
	{
		QFont ftitle("KolertsFont",27,87,false);
		QFont font("KolertsFont",15,10,false);
		
		p.begin( bg_buf ,this);
		p.setBrush(QColor(250,250,250));
		p.setPen(QColor(250,250,250));
		p.drawRect(0, 0, 240, 320);
		p.setBrush(Qt::black);
		p.setPen(Qt::black);
		
		p.drawRect(1, 1, 238, 318);
		
		p.drawPixmap(7, 46, about_icon);	
		
		p.setFont(ftitle);
		p.setPen(QColor(255,100,12));
		p.drawText(57, 72, Rus(title), -1, QPainter::RTL);
		
		p.setFont(font);
		p.setPen(Qt::white);
		p.drawText(59, 88, Rus(text1), -1, QPainter::RTL);
		
		p.drawText(0, 140, 240, 20, Qt::AlignCenter, Rus(text2), -1, 0);
		//p.drawText(7, 150, Rus(text2), -1, QPainter::RTL);
		p.drawText(0, 165, 240, 20, Qt::AlignCenter, Rus(text3), -1, 0);
		//p.drawText(7, 175, Rus(text3), -1, QPainter::RTL);
		p.drawText(0, 270, 240, 20, Qt::AlignCenter, Rus(text4), -1, 0);
		//p.drawText(7, 280, Rus(text4), -1, QPainter::RTL);
		
		p.end();		
		
		bitBlt( this, 0, 0, bg_buf );	
		
		if(exit_count<=0) qApp->quit();
		exit_count--;
	}

void move_up()
	{
		if(y_end<0)
		{
			if (y>=y_end) y=y-move_step;
			if(y<y_end)  y=y_end;
		}
		
		repaint=true;
	}

void move_down()
	{
		if (y<=0)	y=y+move_step;
		if(y>0)	y=0;
		
		repaint=true;
	}

void move_left()
	{
		if(x_end<0)
		{
			if(x>=x_end) x=x-move_step;
			if(x<x_end)  x=x_end;
		}
		
		repaint=true;
	}

void move_right()
	{
		if (x<=0)	x=x+move_step;
		if(x>0)	x=0;
		
		repaint=true;
	}

void zoom_plus()
	{
		paintProc("Change zoom...", false);
		//int procent=4;
		//if(push_green) procent=10;
		zoom_x=zoom_x+(zoom_x/10);
		zoom_y=zoom_y+(zoom_y/10);
		
		/*	zoom_procent=zoom_procent+25;
			zoom_x=pm_w*zoom_procent/100;
			zoom_y=pm_h*zoom_procent/100;
		*/
		zoom_change();
		zoom_c=10;
	}
	
void zoom_minus()
	{
		paintProc("Change zoom...", false);
		//int procent=4;
		//if(push_green) procent=10;
		zoom_x=zoom_x-(zoom_x/10);
		zoom_y=zoom_y-(zoom_y/10);
		zoom_change();
		zoom_c=10;
	}
	
void zoom_reset()
	{
		paintProc("Reset zoom...", false);
		loadFile(image_way, 0);
		x=0;y=0;
		pm_w=pm.width();
		pm_h=pm.height();
		x_end=-pm_w+240;
		y_end=-pm_h+320;
		zoom_x=pm_w;
		zoom_y=pm_h;
		zoom_c=0;
		angle=0;///
		zoom_procent=100;
		///if(angle==90 or angle==180 or angle==270)	rotateImage(angle, false);
		
		repaint=true;
	}

void zoom_disp()
	{
		if(zoom_x==zoom_y)	{zoom_x=240;zoom_y=240;}
		else
		{
			if(zoom_x>zoom_y)	{zoom_x=240;zoom_y=pm_h*zoom_x/pm_w;}
			if(zoom_x<zoom_y)	{zoom_y=320;zoom_x=pm_w*zoom_y/pm_h;}
		}
		x=0;y=0;
		zoom_change();
	}

void zoom_change()
	{
		repaint=false;
		
		if(smoothZoom && recount)
		{
			QImage 	img;
			img = pm.convertToImage();
			img = img.smoothScale( zoom_x, zoom_y );
			pm.convertFromImage( img );
		}
		else
		{
			QWMatrix m;                         // transformation matrix
			m.scale(((double)zoom_x-1)/pm.width(), ((double)zoom_y-1)/pm.height());// define scale factors
			pm=pm.xForm( m );           // create scaled pixmap
		}
		
		zoom_procent=zoom_y*100/pm_h;
		
		x_end=-zoom_x+240;
		y_end=-zoom_y+320;
		
		repaint=true;
		recount=false;
	}

void rotateImage(int angl, bool changes)
{
	if(changes)
		paintProc("Rotating image...", false);
	
	if(angl==90 or angl==270)
	{
		ChangeSizes();
	}
	QPixmap pm_tmp(zoom_x, zoom_y);
	
	p.begin( &pm_tmp ,this);
	p.drawRect( 0, 0, zoom_x, zoom_y );
	
	if(angl==90)
	{
		p.translate(+zoom_x, 0);
		p.rotate(90.0);
		//y=y+zoom_x;
		if(changes)	{angle=angle+90;}
	}
	else if(angl==180)
	{
		p.translate(+zoom_x, +zoom_y);
		p.rotate(180.0);
	}
	else if(angl==270)
	{
		p.translate(0, +zoom_y);
		p.rotate(270.0);
		if(changes) {angle=angle-90;}
	}
	
	if(angle<0) angle=360+angle;
	if(angle>=360) angle=angle-360;
	
	p.drawPixmap(0, 0, pm);
	
	p.end();
	pm=pm_tmp;
	
	repaint=true;
}

void nextImage()
{
	paintProc("Loading next image...", false);
	PrewNextImg=false;
	
	QStringList::ConstIterator it = images.begin();
	bool save=false;bool end=false;
	
	while (!end)
	{
		if(*it!="." && *it!="..")
		{
			if(save)	{image_way=path+"/"+*it;end=true;text=*it;tit_c=30;}
			if (*it==text)
			{
				save=true;
			}
			else
			{
				save=false;
			}
		}
		++it;
		if(it==images.end()) it = images.begin();
	}
	
	loadFile(image_way, 1);
	
	PrewNextImg=true;
}

void prewImage()
{
	paintProc("Loading prew image...", false);
	PrewNextImg=false;
	
	QStringList::ConstIterator it = images.begin();
	QString tmp_text;
	bool tmp_end=false, end=false;
	
	while (!end)
	{
		if(*it!="." && *it!="..")
		{
			if (*it==text && tmp_end)
			{
				image_way=path+"/"+tmp_text;end=true;text=*it;tit_c=30;
			}
			tmp_text=*it;
		}
		++it;
		if(it==images.end()) {it = images.begin(); tmp_end=true;}
	}
	
	loadFile(image_way, 1);
	
	PrewNextImg=true;
}

void setWallPaper()
{
	if(textView->showText("PicView", "Set this image as wallpaper?"+mime_filter, ProgDir+"icon.png", 2))
	{
		SETUP_API* api= new SETUP_API();	
		api->setWallpaper(image_way);
	}
	/*QWallpaper wall;
	QPixmap *wall_buf = new QPixmap(240,320);
	bg_buf=wall.wallpaper();*/
	repaint=true;
}

void DeletePic()
{
	if(textView->showText("PicView", "Remove this picture?", ProgDir+"icon.png", 2))
	{
		QFile f;
		if (f.exists(image_way))
		{	
			f.remove(image_way);
			if(!f.exists(image_way))
			{
				nextImage();
				
				QDir dir( path, mime_filter);
				dir.setMatchAllDirs ( false );
				if ( !dir.isReadable() )
				return;
				images = dir.entryList();
				images.sort();
			}
		}
	}
	repaint=true;
}

void ImgMirror(bool gor, bool ver)
{
	QImage 	img;
	img = pm.convertToImage();
	img = img.mirror( gor, ver );
	pm.convertFromImage( img );
	
	repaint=true;
}

void mainWidget::keyPressEvent(QKeyEvent* k)	//keyReleaseEvent
	{
		SlideShow=false;
		
		switch(k->key())
		{	
			case 4115:	//(Up) 				
				down=true;
				move_step=5;
			break;
			
			case 50:				
				down=true;
				move_step=10;
				if(push_green)move_step=25;
			break;
			
			case 4117:	// (Down)
				up=true;
				move_step=5;
			break;
			
			case 56:
				up=true;
				move_step=10;
				if(push_green)move_step=25;
			break;			
			
			case 4114:	// (Left)
				right=true;
				move_step=5;
			break;
			
			case 52:
				right=true;
				move_step=10;
				if(push_green)move_step=25;
			break;
			
			case 4116:	//(Right)	
				left=true;
				move_step=5;
			break;
			
			case 54:
				left=true;
				move_step=10;
				if(push_green)move_step=25;
			break;
			
			case 4118:	//(volUp)
				zoom_p=true;
			break;
			
			case 4119:	//(volDown)	
				zoom_m=true;
			break;
			
			case 48:	//(0)
				zoom_reset();
			break;
			
			case 35:	//(#)				
				zoom_disp();
				zoom_c=10;
			break;
			
			case 42:	//(*)
				///aniView->loadFile(image_way);
				//ImgMirror(true, false);
				smoothZoom=!smoothZoom;
				if(smoothZoom)
					paintProc("Smooth Zoom: On", false);
				else
					paintProc("Smooth Zoom: Off", false);
			break;
			
			case 4171:	//(prew)
				//prewImg=true;
				if (PrewNextImg)
					prewImage();
			break;
			
			case 4172:	//(next)
				//nextImg=true;
				if (PrewNextImg)
					nextImage();
			break;
			
			case 4169:	//(play)
				SlideShow=!SlideShow;
				if(SlideShow)	slide_timer->start( 5000 );
				else			slide_timer->stop();
			break;
			
			case 4152:	//(90*left)
				rotateImage(270, true);
			break;
			
			case 4154:	//(90*right)
				rotateImage(90, true);
			break;
			
			case 4144:	//green
				push_green=true;
			break;
			
			case 49:	//(1)
				if(push_green)
					gif->setSpeed(gif->speed()-10);
				else
				{
					DrawInfo=!DrawInfo;
					repaint=true;
				}
			break;
			
			case 51:	//(3)
				if(push_green)
					gif->setSpeed(gif->speed()+10);
				else
				{
					RedRect=!RedRect;
					repaint=true;
				}
			break;
			
			case 53:	//(5)
				gifPause=!gifPause;
				if(gifPause)
				{
					gif->pause();
					paintProc("Animation pause", true);
				}
				else
				{
					gif->unpause();
					paintProc("Animation unpause", true);
				}
			break;
			
			case 55:	//(7)
				setWallPaper();
			break;
			
			case 57:	//(9)
				DeletePic();
			break;
// ----------------------------
			case 4145:	//(exit)
				exit=true;
				gif->pause();
			break;
			
			default:			
			break;
		}			
	}
	
void mainWidget::keyReleaseEvent(QKeyEvent* k)	//keyReleaseEvent
	{		
		switch(k->key())
		{	
			case 4115:	//(Up) 				
				down=false;
			break;
			
			case 50:				
				down=false;
			break;
			
			case 4117:	// (Down)
				up=false;
			break;
			
			case 56:
				up=false;
			break;			
			
			case 4114:	// (Left)
				right=false;
			break;
			
			case 52:
				right=false;
			break;
			
			case 4116:	//(Right)	
				left=false;
			break;
			
			case 54:
				left=false;
			break;
			
			case 4118:	//(volUp)
				zoom_p=false;
			break;
			
			case 4119:	//(volDown)				
				zoom_m=false;
			break;
			
			/*case 4171:	//(prew)
				prewImg=false;
			break;
			
			case 4172:	//(next)
				nextImg=false;
			break;*/
			
			case 4144:	//green
				push_green=false;
			break;
			
			default:			
			break;
		}			
	}

QString getPath ( const QString &AFileName )
{
  QString str = AFileName;
  int i = str.findRev ( "/" );
  str.remove ( i+1, str.length() - i );
  return str;
}

QString getFileName(const QString &AFileName)
{
	QString str = AFileName;
	int i = str.findRev("/");
	str.remove(0, i);
	if (str.left(1) = "/") str.remove(0, 1);
	return str;
}

QString getMime(const char*ChineseString)
{
	QString str = ChineseString;
	int i = str.findRev (".");
	if (i==-1) return false;
	else return str.mid(i+1,str.length()-i);
}

QString getWorkDir ( const QString &AFileName )
{
  QString str = AFileName;
  int i = str.findRev ( "/plugins" );
  str.remove ( i+1, str.length() - i );
  return str;
}

/*QString getFmDir()
{
	QString fm_path="/mmc/mmca1/.system/QTDownLoad/fm/";
	if (QFile(fm_path).exists())
		qDebug("fm_path=\"/mmc/mmca1/.system/QTDownLoad/fm/\"");
	else
	{
		fm_path="/ezxlocal/.system/QTDownLoad/fm/";
		if (QFile(fm_path).exists())
			qDebug("fm_path=\"/ezxlocal/.system/QTDownLoad/fm/\"");
		else
			qDebug("ERORR! cant found FsMan");
	}

	return fm_path;
}*/

void setImgChar()
{
	x=0;
	y=0;
	pm_w=pm.width();
	pm_h=pm.height();
	x_end=-pm_w+240;
	y_end=-pm_h+320;
	zoom_x=pm_w;
	zoom_y=pm_h;
	zoom_c=0;
	angle=0;
	zoom_procent=100;
	
	text=getFileName(image_way);
	resol=QString("%1 x %2").arg(pm_w).arg(pm_h);
	
	countSize();
	if(pm_w>240 && pm_h>320)
	{
		if(pm_w>pm_h)	rotateImage(90, true);
		zoom_disp();
	}
}

void ChkPos()
{
	if(y<y_end)  y=y_end;
	if(x<x_end)  x=x_end;
	if(y>0)	y=0;
	if(x>0)	x=0;
	
	if(zoom_x<240) x=(240-zoom_x)/2;
	if(zoom_y<320) y=(320-zoom_y)/2;
}

void ChangeSizes()
{
	int temp_h=zoom_y;
	zoom_y=zoom_x;zoom_x=temp_h;
	temp_h=pm_h;
	pm_h=pm_w;pm_w=temp_h;
	x_end=-zoom_x+240;
	y_end=-zoom_y+320;
}

void countSize()
{
	QFileInfo *fInfo = new QFileInfo (image_way);
	int siz=fInfo->size();
	if (size < 1024)
	{
		size=QString("%1 b").arg(siz);
	} else if (siz < 1024 * 1024)
	{
		size=QString("%1 Kb").arg(siz / 1024);
	} else
	{
		size=QString("%1 Mb").arg(siz / 1024 / 1024);
	}
}

void slideShow()
	{
		if(SlideShow)	nextImage();
		else	slide_timer->stop();
	}
	
public slots:

void animate()
	{
		//img = pm.convertToImage();
		//img = img.smoothScale( zoom_x, zoom_y );
		//pm.convertFromImage( img );
		if (up) 	move_up();
		if (down) 	move_down();
		if (left) 	move_left();
		if (right) 	move_right();
		if (zoom_p) zoom_plus();
		if (zoom_m) zoom_minus();
		
		/*if (PrewNextImg)
		{
			if(nextImg) nextImage();
			if(prewImg) prewImage();
		}*/
		
		if (!exit)
		{
			if(repaint)
				paint();
			
			if(tit_c==0)
				paint();
			if(tit_c>=0)
				tit_c--;
		}
		else 		paintAbout();
		
		//paintProc("Image processing...", false);
		if(zoom_c==1 && !animated)
		{
			recount=true;
			paintProc("Recounting pixels...", true);
			///pm=pm_temp;
			///pm=QPixmap(image_way);
			loadFile(image_way, 0);
			if(angle==90 or angle==270) ChangeSizes();
			zoom_change();
			if(angle==90 or angle==180 or angle==270)	rotateImage(angle, false);
		}
		if(zoom_c>0)
			zoom_c--;
	}

void gifUpdated()
	{
		if(!exit)
		{
			pm=gif->framePixmap();
			recount=true;
			if(angle==90 or angle==270)	ChangeSizes();
			zoom_change();
			if(angle==90 or angle==180 or angle==270) rotateImage(angle, false);
			paint();
		}
		animated=true;
	}
	
bool ypoCkhc()
	{
		bool ret=true;
		
		title=QString("PicView 1.0.5");
		text1=QString("Pic viewer for ROKR E2");
		
		char txt2[35] =
		{
			(char)40,	(char)99,	(char)41,	(char)32,	(char)87,	(char)114,	(char)105,	(char)116,	(char)116,
			(char)101,	(char)110,	(char)32,	(char)98,	(char)121,	(char)32,	(char)83,	(char)116,	(char)114,
			(char)101,	(char)108,	(char)111,	(char)107,	(char)32,	(char)86,	(char)108,	(char)97,	(char)100,
			(char)32,	(char)75,	(char)111,	(char)108,	(char)101,	(char)114,	(char)116,	(char)115
		};
		
		/*char txt3[18] =
		{
			(char)97,	(char)100,	(char)109,	(char)105,	(char)110,	(char)64,	(char)109,	(char)111,	(char)98,
			(char)115,	(char)107,	(char)46,	(char)111,	(char)114,	(char)103,	(char)46,	(char)117,	(char)97
		};*/
		char txt3[15] =
		{
			(char)107,	(char)111,	(char)108,	(char)101,	(char)114,	(char)116,	(char)115,	(char)64,	(char)117,
			(char)107,	(char)114,	(char)46,	(char)110,	(char)101,	(char)116
		};
		
		/*char txt4[17] =
		{
			(char)104,	(char)116,	(char)116,	(char)112,	(char)58,	(char)47,	(char)47,	(char)77,	(char)111,
			(char)116,	(char)111,	(char)70,	(char)97,	(char)110,	(char)46,	(char)82,	(char)85
		};*/
		
		char txt4[15] =
		{
			(char)104,	(char)116,	(char)116,	(char)112,	(char)58,	(char)47,	(char)47,	(char)101,	(char)50,
			(char)46,	(char)97,	(char)116,	(char)46,	(char)117,	(char)97
		};
		
		for(int i=0; i<35; i++)
		{
			text2+=QString("%1").arg(txt2[i]);
		}
		
		for(int i=0; i<15; i++)
		{
			text3+=QString("%1").arg(txt3[i]);
		}
		
		for(int i=0; i<15; i++)
		{
			text4+=QString("%1").arg(txt4[i]);
		}
		
		//(c) Written by Strelok Vlad Kolerts
		
		if(title.mid( 5, 2 )!="ew" && ret) ret=false;
		if(text1.mid( 4, 1 )!="v" && ret) ret=false;
		if(text1.mid( 11, 1 )!="f" && ret) ret=false;
		
		if(text2.mid( 18, 1 )!="e" && ret) ret=false;
		if(text2.mid( 25, 1 )!=QString("%1").arg((char)97) && ret) ret=false;
		if(text3.mid( 8, 3 )!="ukr" && ret) ret=false;
		if(text3.mid( 2, 1 )!=QString("%1").arg((char)108) && ret) ret=false;
		if(text4.mid( 13, 2 )!=QString("%1%2").arg((char)117).arg((char)97) && ret) ret=false;
		
		return ret;
	}
};

int main( int argc, char **argv )
{
	ZApplication* a = new ZApplication( argc, argv );
	mainWidget* mw = new mainWidget(Rus(argv[2]));
   	a->setMainWidget( mw );
	mw->show();
	a->processEvents();
	mw->paintAbout();
	a->processEvents();
	mw->loadFile(Rus(argv[2]), 1);
	int ret = a->exec();
	delete mw;
	delete a;
   	return ret;
}

#include "tmp/pview.moc"
